define([
    "../../../widgets/_ComplexValueWidget",
    "dijit/form/CheckBox",
    "dijit/form/RadioButton",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/text!./templates/MultipleChoiceInputWidget.html"
], function(_ComplexValueWidget, CheckBox, RadioButton, array, declare, domConstruct, template) {
    return declare([_ComplexValueWidget],{
        templateString: template,
        allowMultiple: false,
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);

            domConstruct.empty(this.domNode);
            var Ctor = this.allowMultiple === true ? CheckBox : RadioButton;
            array.forEach(this.items, function(item, index){
                var div = domConstruct.create("div", {
                }, this.domNode, "last");
                var input = new Ctor({
                    name: this.allowMultiple === true ? index.toString() : 'choice',
                    value: item.text
                }).placeAt(div);
                var label = domConstruct.create("label",{
                    'for': input.id,
                    innerHTML: item.text
                }, div);
            }, this);
        },
        _getValueAttr: function() {
            var value = this.inherited(arguments);
            if ( this.allowMultiple === true ) {
                return value;
            } else {
                return value.choice;
            }
        },
        _setValueAttr: function(value) {
            var inherited = this.getInherited(arguments);
            if ( this.allowMultiple === true ) {
                inherited.call(this,value);
            } else {
                inherited.call(this,{choice:value});
            }
        }
    });
});
